]> sourceware.org Git - glibc.git/commitdiff
rtld: Add test case for '--' option
authorHenrik Lindström <henrik@lxm.se>
Fri, 26 Jul 2024 10:33:51 +0000 (12:33 +0200)
committerAdhemerval Zanella <adhemerval.zanella@linaro.org>
Tue, 6 Aug 2024 13:53:24 +0000 (10:53 -0300)
Reviewed-by: Adhemerval Zanella <adhemerval.zanella@linaro.org>
elf/Makefile
elf/tst-rtld-dash-dash.sh [new file with mode: 0644]

index a03c6520d80fe61ac60d3f3cc6e6466cccc0d067..0792b5767854e74d0fd20d2afd6316fd3ce2592e 100644 (file)
@@ -634,6 +634,13 @@ $(objpfx)tst-rtld-does-not-exist.out: tst-rtld-does-not-exist.sh $(objpfx)ld.so
        $(SHELL) $< $(objpfx)ld.so > $@; \
        $(evaluate-test)
 
+ifeq ($(run-built-tests),yes)
+tests-special += $(objpfx)tst-rtld-dash-dash.out
+endif
+$(objpfx)tst-rtld-dash-dash.out: tst-rtld-dash-dash.sh $(objpfx)ld.so
+       $(SHELL) $< $(objpfx)ld.so > $@; \
+       $(evaluate-test)
+
 tests += $(tests-execstack-$(have-z-execstack))
 ifeq ($(run-built-tests),yes)
 tests-special += \
diff --git a/elf/tst-rtld-dash-dash.sh b/elf/tst-rtld-dash-dash.sh
new file mode 100644 (file)
index 0000000..2bc1f85
--- /dev/null
@@ -0,0 +1,41 @@
+#!/bin/sh
+# Test for the '--' option in ld.so.
+# Copyright (C) 2024 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2.1 of the License, or (at your option) any later version.
+
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+
+# You should have received a copy of the GNU Lesser General Public
+# License along with the GNU C Library; if not, see
+# <https://www.gnu.org/licenses/>.
+
+export LC_ALL=C
+
+# --inhibit-cache to suppress "No such file or directory" message when
+# /etc/ld.so.cache does not exist.
+rtld="$1 --inhibit-cache"
+tmp_out="$(mktemp)"
+
+$rtld -- --program-does-not-exist 2>"$tmp_out"
+status=$?
+echo "$rtld exit status: $status"
+echo "output (with expected error):"
+cat "$tmp_out"
+
+if test $status -eq 127 \
+       && grep -q "^--program-does-not-exist: error while loading shared libraries: --program-does-not-exist: cannot open shared object file$" "$tmp_out" \
+       && test "$(wc -l < "$tmp_out")" -eq 1 ; then
+    status=0
+else
+    status=1
+fi
+rm "$tmp_out"
+exit $status
This page took 0.04528 seconds and 5 git commands to generate.